
;***************************   HD44780  *******************************     
;***************************  Checksum  0xa812   *******************************

	list     p=pic16f628a

	include  P16f628a.inc
    
    __CONFIG   3f14h
 
	errorlevel +207

cblock  0x20

rg_ligt
rg_int
phaze_tmp
W_TEMP
ST_TEMP
LCD_tmp 
dig_lo
dig_hi
bcd1
bcd2
bcd3
bin1
bin2
ctr
TenK 
Thou 
Hund 
Tens 
Ones 
      
endc
           
#define bank0    bcf STATUS,RP0       
#define bank1    bsf STATUS,RP0

#define phase_1  sublw b'00011000'
#define phase_2  sublw b'00010000'
#define phase_3  sublw b'00000000'
#define phase_4  sublw b'00001000'

#define func_on  btfss PORTA,2
#define func_off btfsc PORTA,2 

#define D7_1     bsf PORTA,1 
#define D7_0     bcf PORTA,1 
#define D6_1     bsf PORTA,0 
#define D6_0     bcf PORTA,0 
#define D5_1     bsf PORTA,7 
#define D5_0     bcf PORTA,7  
#define D4_1     bsf PORTA,6 
#define D4_0     bcf PORTA,6  

#define RS_1     bsf PORTB,4 
#define RS_0     bcf PORTB,4    
#define E_1      bsf PORTB,6 
#define E_0      bcf PORTB,6 

#define Ligt_on  bsf PORTB,5 
#define Ligt_off bcf PORTB,5 

#define CS_1     bsf PORTB,7
#define CS_0     bcf PORTB,7
#define CLK_1    bsf PORTB,0
#define CLK_0    bcf PORTB,0
#define Din_1    bsf PORTB,2
#define Din_0    bcf PORTB,2
#define Dout_1   btfsc PORTB,1
#define Dout_0   btfss PORTB,1
#define strob    call  strb 
                                          
        ORG      0h                   
        goto     Init 
;******************************************************************************* 
;************       **************************************
        ORG      4h                ;    
        movwf    W_TEMP            ;  W   - 
        movf     STATUS,W          ;  STATUS  W 
        movwf    ST_TEMP           ;  W   - 
;**********************

        comf     rg_int,f          ;                
        btfsc    rg_int,0          ;    (   ) 
        goto     m_down                                      
                                   ;       
        btfsc    phaze_tmp,3       ;    3     
        goto     ph_4
        btfsc    phaze_tmp,2       ;    2     
        goto     ph_3
        btfsc    phaze_tmp,1       ;    1       
        goto     ph_2

ph_1    movf     PORTA,w
        andlw    b'00011000'       ;     W
        clrz
        phase_1                    ;    (  1 )
        skpz                       ;   c ,  .            
        goto     end_int
        bsf      phaze_tmp,1       ;    (  1  )
            
ph_2    movf     PORTA,w
        andlw    b'00011000'       ;     W
        clrz
        phase_2                    ;    (  2 )
        skpz                       ;    = 0 ,  .            
        goto     end_int
        bsf      phaze_tmp,2       ;    (  2  )
                     
ph_3    movf     PORTA,w
        andlw    b'00011000'       ;     W
        clrz
        phase_3                    ;    (  3 )
        skpz                       ;    = 0 ,  .            
        goto     end_int
        bsf      phaze_tmp,3       ;    (  3  )
           
ph_4    movf     PORTA,w
        andlw    b'00011000'       ;     W
        clrz
        phase_4                    ;    (  4 )
        skpz                       ;    = 0 ,  .            
        goto     end_int

        clrz
        comf     CCPR1L,w          ;  CCPR1L = 255 ,  
        skpnz
        clrf     phaze_tmp         ;        
        skpnz
        goto     end_int
        
        incf     CCPR1L,f
        ;movf     CCPR1L,w          ;      dig_lo           
        ;movwf    dig_lo

        clrf     phaze_tmp         ;        

        goto     end_int           ;       
                       
m_down  btfsc    phaze_tmp,6       ;          
        goto     ph_8
        btfsc    phaze_tmp,5          
        goto     ph_7
        btfsc    phaze_tmp,4            
        goto     ph_6

ph_5    movf     PORTA,w
        andlw    b'00011000'    
        clrz
        phase_3                 
        skpz                                 
        goto     end_int
        bsf      phaze_tmp,4     
            
ph_6    movf     PORTA,w
        andlw    b'00011000'     
        clrz
        phase_2                  
        skpz                              
        goto     end_int
        bsf      phaze_tmp,5     
                     
ph_7    movf     PORTA,w
        andlw    b'00011000'   
        clrz
        phase_1                
        skpz                              
        goto     end_int
        bsf      phaze_tmp,6      
           
ph_8    movf     PORTA,w
        andlw    b'00011000'    
        clrz
        phase_4                  
        skpz                                
        goto     end_int

        clrz
        movf     CCPR1L,w           ;  CCPR1L = 0 ,  
        skpnz
        clrf     phaze_tmp          ;        
        skpnz
        goto     end_int
        
        decf     CCPR1L,f
        ;movf     CCPR1L,w           ;      dig_lo      
        ;movwf    dig_lo

        clrf     phaze_tmp          ;        

        goto     end_int            ;        

end_int clrf     TMR0               ;           
        bcf      INTCON,2
        CLRWDT 
;**********************
        movf    ST_TEMP,W           ;     STATUS 
        movwf   STATUS              ;  W
        swapf   W_TEMP,f
        swapf   W_TEMP,W
        retfie                      ;    GIE   1                                                      
;*******************************************************************************
;***********      ************************************** 
Init 			
        bank1
        movlw    b'11111111'          
        movwf    PR2^80H            ;    
        movlw    b'00111100'           
        movwf    TRISA
        movlw    b'00000010'
        movwf    TRISB
	    movlw    b'00000000'        
        movwf    OPTION_REG^80H
        movlw    b'10100000'
        movwf	 INTCON	    	    ;    TMR0
        bank0
        movlw    b'00000000' 
        movwf    CCPR1L             ;   
        movlw    b'00001100'    
        movwf    CCP1CON            ;   (  4  5    )
        movlw    b'00000100'
        movwf    T2CON              ;   2
        movlw    .49
        movwf    T1CON              ;  TMR1 c  

        clrf	 RCSTA			    ;   .  USART
        clrf     PORTA  
        clrf     PORTB
        movlw    0x07
	    movwf	 CMCON			    ;   
        CS_1                        ;     
;******************************************************************************* 
;***********       *****************************************
nop
        ;call     Conversion
nop 
;*******************************************************************************
;***********      ****************************************** 
        call     del_100ms         ;   100  
        movlw    b'00110011'       ;     8  
        call     LCD_com           ;  30h 3     20h
        movlw    b'00110010'       ;    ,    
        call     LCD_com           
        movlw    b'00100000';20h   ;     42  
        call     LCD_com
        movlw    b'00001100';0Ch   ;    
        call     LCD_com
        movlw    b'00000110';06h   ;    
        call     LCD_com
        movlw    b'00101000'       ;   
        call     LCD_com
        movlw    b'10000000'       ;     
        call     LCD_com
        movlw    b'00000001'       ;   
        call     LCD_com 
;*******************************************************************************
;***********      *********************************************
BEGIN  
        movlw    0x85              ;      ( 0x80 -  )
        call     LCD_com
        movlw    0x55              ; U
        call     LCD_dig 
 
        movlw    0x20              ;   
        call     LCD_dig

        movlw    0x3D              ; =  
        call     LCD_dig
 
        movlw    0x8E              ;      ( 0x80 -  )
        call     LCD_com
        movlw    0x56              ; V
        call     LCD_dig
 

        movlw    0xC5              ;      ( 0x0 -  )
        call     LCD_com 
        movlw    0x49              ; I
        call     LCD_dig 

        movlw    0x20              ;   
        call     LCD_dig 

        movlw    0x3D              ; =        
        call     LCD_dig 

        movlw    0xCE              ;      ( 0x0 -  )
        call     LCD_com 
        movlw    0x41              ; A
        call     LCD_dig
 
        
        

        ;movlw    b'00000000'
        ;movwf    dig_lo

        ;movlw    b'00000000'
        ;movwf    dig_hi

        clrf     phaze_tmp
        clrf     rg_ligt

        call     EEPROM_RD         ;     
        
        ;movwf    dig_lo            ;    dig_lo   


;******************************************************************************* 
;***********         **************************************

        call     LCD_mov
        func_on                    ;    
        call     Func
        goto     $-3

;******************************************************************************* 
;*******************************************************************************
TABL_dig
        andlw  b'00001111'         ;    W
        addwf  PCL,f
        retlw  0x30 
        retlw  0x31 
        retlw  0x32 
        retlw  0x33 
        retlw  0x34 
        retlw  0x35  
        retlw  0x36 
        retlw  0x37 
        retlw  0x38 
        retlw  0x39
;******************************************************************************* 
;*******************************************************************************
Func    clrf     TMR1L
        clrf     TMR1H
        bcf      PIR1,0
        func_off                   ;      0,5  
        goto     $+5 
        btfss    PIR1,0
        goto     $-3
        call     EEPROM_WR         ;    
        goto     $+6 
        comf     rg_ligt,f         ;    
        btfss    rg_ligt,0
        Ligt_off                   ;   
        btfsc    rg_ligt,0
        Ligt_on                    ;  
        func_off                   ;   
        return
        goto     $-2         
;******************************************************************************* 
;*******************************************************************************
TRANSFORMER_dig
;***********
 movf    dig_lo,W              ;       
 movwf   bin2                  ;  bin2               
 movf    dig_hi,W              ;       
 movwf   bin1                  ;  bin1
;***********
;bin2 =    
;bin1 =    

;bcd3 (   ) = 
;bcd3 (   ) = 
;bcd2 (   ) = 
;bcd2 (   ) = 
;bcd1 (   ) =   
;***********                                               
Bin_bcd                         ;                         
bin2bcd movlw    .16 
        movwf    ctr 
        clrf     bcd1 
        clrf     bcd2 
        clrf     bcd3 
        goto     start 
adjdec  movlw    0x33 
        addwf    bcd1,f 
        addwf    bcd2,f 
        addwf    bcd3,f 
        movlw    0x03 
        btfss    bcd1,3 
        subwf    bcd1,f 
        btfss    bcd2,3 
        subwf    bcd2,f 
        btfss    bcd3,3 
        subwf    bcd3,f 
        movlw    0x30 
        btfss    bcd1,7 
        subwf    bcd1,f 
        btfss    bcd2,7 
        subwf    bcd2,f 
        btfss    bcd3,7 
        subwf    bcd3,f 
start   rlf      bin2,f 
        rlf      bin1,f 
        rlf      bcd3,f 
        rlf      bcd2,f 
        rlf      bcd1,f 
        decfsz   ctr,f 
        goto     adjdec          ;     
                       
        movf    bcd1,w           ;             
        call    TABL_dig
        movwf   TenK             ;   

        swapf   bcd2,w
        call    TABL_dig
        movwf   Thou             ;  

        movf    bcd2,w
        call    TABL_dig
        movwf   Hund             ;  

        swapf   bcd3,w
        call    TABL_dig
        movwf   Tens             ;  

        movf    bcd3,w
        call    TABL_dig
        movwf   Ones             ; 

        return         
;******************************************************************************* 
;*******************************************************************************
LCD_mov 
        call     CH_U            
        call     Conversion      ;   (   600 ns ) 

        movlw    0x88            ;      ( 0x80 -  )
        call     LCD_com 

        call     TRANSFORMER_dig  

        ;movf     TenK,w
        ;call     LCD_dig

        clrz
        movlw    0x30
        subwf    Thou,w          
        skpnz
        movlw    0x20
        skpnz
        movwf    Thou            ;    ,   0  
          
        movf     Thou,w
        call     LCD_dig    
        
        movf     Hund,w
        call     LCD_dig

        movlw    0x2C            ;  
        call     LCD_dig  

        movf     Tens,w
        call     LCD_dig
 
        ;movf     Ones,w
        ;call     LCD_dig 

;**************
        call     CH_I 
        call     Conversion      ;   (   600 ns ) 
        
        movlw    0xC9            ;      ( 0x0 -  )
        call     LCD_com 

        call     TRANSFORMER_dig  

        ;movf     TenK,w
        ;call     LCD_dig
 
        movf     Thou,w
        call     LCD_dig

        movlw    0x2C           ;  
        call     LCD_dig 
 
        movf     Hund,w
        call     LCD_dig 

        movf     Tens,w
        call     LCD_dig
 
        ;movf     Ones,w
        ;call     LCD_dig 

        return  
;******************************************************************************* 
;*******************************************************************************
LCD_dig
        movwf    LCD_tmp        ;   
        E_0
        RS_1  
        call     LCD_load
        return 
;******************************************************************************* 
;*******************************************************************************
LCD_com                         ;  
        movwf    LCD_tmp
        E_0
        RS_0   
        call     LCD_load
        return     
;******************************************************************************* 
;*******************************************************************************
LCD_load                         ;     
        btfsc    LCD_tmp,7       ;  
        D7_1      
        btfss    LCD_tmp,7
        D7_0
        btfsc    LCD_tmp,6
        D6_1      
        btfss    LCD_tmp,6
        D6_0
        btfsc    LCD_tmp,5
        D5_1      
        btfss    LCD_tmp,5
        D5_0
        btfsc    LCD_tmp,4
        D4_1      
        btfss    LCD_tmp,4
        D4_0
        E_1
        call     del_1ms
        E_0
        call     del_1ms
        btfsc    LCD_tmp,3
        D7_1      
        btfss    LCD_tmp,3
        D7_0
        btfsc    LCD_tmp,2
        D6_1      
        btfss    LCD_tmp,2
        D6_0
        btfsc    LCD_tmp,1
        D5_1      
        btfss    LCD_tmp,1
        D5_0
        btfsc    LCD_tmp,0
        D4_1      
        btfss    LCD_tmp,0
        D4_0
        E_1
        call     del_1ms
        E_0
        call     del_1ms     
        return 
;******************************************************************************* 
;***********    500 ms *************************************************
del_500ms 
        clrf   TMR1L                
        clrf   TMR1H            
        bcf    PIR1,0                      
        btfss  PIR1,0
        goto   $-1 
        return            
;******************************************************************************* 
;***********    100 ms *************************************************
del_100ms 
        call   del_50ms
        call   del_50ms
        return
;******************************************************************************* 
;***********    50 ms *************************************************
del_50ms 
        clrf   TMR1L                
        movlw  .232
        movwf  TMR1H              
        bcf    PIR1,0                      
        btfss  PIR1,0
        goto   $-1 
        return                                    
;******************************************************************************* 
;***********    1 ms  **************************************************
del_1ms 
        movlw  .136
        movwf   TMR1L                
        movlw  .255
        movwf  TMR1H              
        bcf    PIR1,0                      
        btfss  PIR1,0
        goto   $-1 
        return
;******************************************************************************* 
;***********    10 ns  **************************************************
del_10ns 
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        return
;*******************************************************************************
;*******************************************************************************
EEPROM_RD
        CLRWDT
        bcf	     INTCON,GIE		  ;  
        movlw    .0               ;   EEADR  
        banksel  EEADR  
        movwf    EEADR            ;    EEPROM
	    bsf      EECON1,RD        ;  
	    movf     EEDATA,W         ;   W   
        bsf	     INTCON,GIE       ;  
        bank0
        movwf    CCPR1L
        return
;*******************************************************************************
;*******************************************************************************
EEPROM_WR 
        CLRWDT
        bcf	      INTCON,GIE	  ;    
        movlw     .0              ;     
        banksel   EEADR
        movwf     EEADR
        bank0
        movf      CCPR1L,w        ;     
        banksel   EEDATA
        movwf     EEDATA
        banksel   EECON1
        bsf	      EECON1,WREN     ;    PROM 
        call      ee_wr
        bsf	      INTCON,GIE      ;  
        return
;*******************************************************************************
;*******************************************************************************
ee_wr   CLRWDT
        banksel   EECON2
     	movlw     55H            		 
	    movwf     EECON2		       
    	movlw     0AAH			        
    	movwf     EECON2		  ;      EEPROM
    	bsf	      EECON1,WR	      ;    EEPROM   EEADR
ee_wr1	CLRWDT
        banksel   EECON1;
        btfsc	  EECON1,WR	      ;   ?
	    goto      ee_wr1		  ; 
        banksel   EECON1;
        bcf    	  EECON1,WREN	  ;    PROM
        bank0
        return           
;*******************************************************************************  
;*******************************************************************************    
CH_U    clrf      dig_lo
        clrf      dig_hi
        bcf	      INTCON,GIE	   ;    
        CS_0                       ;    
        Din_1                      ; c                                          
        strob
        Din_1                      ; SGL/DIFF                      
        strob
        Din_0                      ; ODD/SIGN                     
        strob
        Din_1                      ; MC/BF                      
        strob
        Din_0                      ;     
        return 
;*******************************************************************************  
;*******************************************************************************    
CH_I    clrf      dig_lo
        clrf      dig_hi
        bcf	      INTCON,GIE	   ;    
        CS_0                       ;    
        Din_1                      ; c                                          
        strob
        Din_1                      ; SGL/DIFF                      
        strob
        Din_1                      ; ODD/SIGN                     
        strob
        Din_1                      ; MC/BF                      
        strob
        Din_0                      ;     
        return 
;*******************************************************************************  
;*******************************************************************************
Conversion
       
        CLK_0
        call       del_10ns 
        Dout_1                     ;   (  = 0 )
        bsf        dig_hi,4                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns
        Dout_1                     ; 11   
        bsf        dig_hi,3                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns
        Dout_1                     ; 10   
        bsf        dig_hi,2                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns
        Dout_1                     ; 9   
        bsf        dig_hi,1                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns
        Dout_1                     ; 8   
        bsf        dig_hi,0                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns 
        Dout_1                     ; 7   
        bsf        dig_lo,7                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns 
        Dout_1                     ; 6   
        bsf        dig_lo,6                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns
        Dout_1                     ; 5   
        bsf        dig_lo,5                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns 
        Dout_1                     ; 4   
        bsf        dig_lo,4                  
        CLK_1
        call       del_10ns    

        CLK_0
        call       del_10ns 
        Dout_1                     ; 3   
        bsf        dig_lo,3                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns
        Dout_1                     ; 2   
        bsf        dig_lo,2                  
        CLK_1
        call       del_10ns

        CLK_0
        call       del_10ns 
        Dout_1                     ; 1   
        bsf        dig_lo,1                  
        CLK_1
        call       del_10ns 
        
        CLK_0
        call       del_10ns 
        Dout_1                     ; 0   
        bsf        dig_lo,0                  
        CLK_1
        call       del_10ns

        CS_1                       ;    
        
        bsf	      INTCON,GIE      ;  
        
        return
;*******************************************************************************  
;*******************************************************************************
strb    CLK_0
        call       del_10ns
        CLK_1
        call       del_10ns
        return 
;*******************************************************************************  
;******************************************************************************* 
        end
